
<p align="center">
<img src="https://github.com/Not-Enough-Photons/MonoDirector/blob/main/img/logo.png?raw=true" alt="MagPerception" width = 800px>
</img>
</p>

**MonoDirector** is BONELAB's very own movie/photo suite. Make an action movie, mockumentary, or a group photo all **by yourself.** You are the director, actor and cameraman. Make whatever you want.

This mod is open-sourced for open beta, and I want to get this mod to where it should be. Ideally, it should just be a strong enough tool to where anyone can make films by themselves without the aid of another person. It will take a lot of time and effort to make this happen, and you can certainly contribute!

I hope this mod over time reaches my grand vision. Be patient with us, and we'll try out best to get it right.

![](https://github.com/Not-Enough-Photons/MonoDirector/blob/main/img/banner_installation.png?raw=true)
To install MonoDirector, ensure that you the above dependencies installed:
- MelonLoader
- BoneLib
- JeviLib
- AudioImportLib

The installation will vary a bit if you're installing for Quest, but it is straightforward.

1. Open the zip file
2. Go inside the **"Code Mod"** folder
3. Drag all contents of the folder into your game directory

For installing the items:
1. Go inside of the folder that goes with your headset
	1. Select PCVR if you use a PC, Quest if otherwise
2. Drag **"NotEnoughPhotons.MonoDirector"** into where you install your items

![](https://github.com/Not-Enough-Photons/MonoDirector/blob/main/img/banner_perform.png?raw=true)
If you ever want to act out a scene, but you don't have any friends, MonoDirector has you covered. Simply record from hitting the button on the menu, and all of your movements are recorded.

A strength of the tool is being able to be there with your clones. It certainly helps with whatever scenes you have planned out. On top of this, if you want to voice act, you can enable it in the settings. Now when you record, it will also record your voice. The voice gets played back in real time, when you both record and play back. The possibilities are endless.

![](https://github.com/Not-Enough-Photons/MonoDirector/blob/main/img/banner_tools.png?raw=true)
MonoDirector provides a (decent) set of tools for any situation that suits your needs.

For example, if you want to have your actors interact with props, you can use the Propifier to set them up. Then when recording begins, your actor will be able to pick up the prop, and then in playback, it'll copy the recorded movements.

The propifier doesn't **only** work on props, though. It works on any of these (to an extent):
- Guns
- Vehicles
- Breakable Objects

Another tool of interest is the Gimbal Camera. This camera is a handheld camera, that can be enabled in the settings under the Camera category.

The Gimbal Camera allows for steady handheld shots. Shots where the camera needs to be close to action, or a subject (or subjects) of interest. Note though, this item will come at a performance cost.

When enabled, the viewfinder screens on the camera will show up, and now wherever you point the camera, you can see where its facing. The right trigger increases the FOV of the camera, and then the left trigger decreases the FOV. 

![](https://github.com/Not-Enough-Photons/MonoDirector/blob/main/img/banner_direct.png?raw=true)
When all is said and done, and you have all the actors in their right places, now it is time to finally direct everything. Playback everything, get your camera ready, and record. It's that simple when you're doing it solo.

![](https://github.com/Not-Enough-Photons/MonoDirector/blob/main/img/banner_credits.png?raw=true)
- [zCubed](https://github.com/zCubed3) for helping out with the project (helped get interpolation in!)
- [wnp](https://github.com/wnp78) and [Someone Somewhere](https://github.com/someonesomewheredev) for helping with audio syncing
- [Son of Forehead](https://github.com/SonOfForehead) for the clapperboard, green screens, and the prop lights
- [CarrionAndOn](https://github.com/CarrionAndOn) for the addition of a handheld camera, and most of the feedback
- **Rexmeck** for helping with grip event recording
- **Stress Level Zero** for BONELAB and the Marrow SDK


![](https://github.com/Not-Enough-Photons/MonoDirector/blob/main/img/banner_support.png?raw=true)
Want to support me and my future projects? 
[You can donate at my Ko-fi!](https://ko-fi.com/adamdev)